package dados;

import java.io.Serializable;
import java.text.DecimalFormat;
import fundamentos.Comparable;

import fundamentos.AbstractObject;

public class DataArea
	extends AbstractObject
	implements Serializable
{
    private int numero;
    private String nome;
    double salario;    
    
    public DataArea( int numero, String nome, double salario )
    {
    	this.numero 	= numero;
    	this.nome 		= nome;
    	this.salario 	= salario;
    }
    
    public DataArea()
    {
        this(-1, "", 0f);    	
    }
    
    public int getNumero()
    {
    	return numero;
    }
    
    public String getNome()
    {
    	return nome;
    }
    
    public double getSalario()
    {
    	return salario;
    }
    
    public void setNumero( int numero )
    {
    	this.numero = numero;
    }
    
    public void setNome( String nome )
    {
    	this.nome = nome;
    }
    
    public void setSalario( double salario )
    {
    	this.salario = salario;
    }
    
    /*public void imprime()
    {
    	System.out.println ("Numero = " + numero + "  Nome = " + nome + "  Salario = " + salario);
    }*/
    
    public String toString()
	{
        /*NumberFormat nf = NumberFormat.getNumberInstance();
        nf.setMaximumFractionDigits (2);
        nf.setMinimumFractionDigits (2);*/
        DecimalFormat formatoDoFloat = new DecimalFormat("0.00");
        DecimalFormat formatoDoInt = new DecimalFormat("00");
        
	    String dataArea = "Numero: " + formatoDoInt.format(numero) + 
	    	" Nome: " + nome + 
	    	" Salario: " + formatoDoFloat.format(salario) +
	    	"\n";
	    return dataArea;
	}
    
    /*
     * Retorna 0 se for igual, retorna negativo se for menor(no caso:
     * alfabeticamente), e retorna positivo se for maior.
     */
    protected int compareTo (Comparable object)
    {
		DataArea arg = (DataArea) object;
		//return (int) numero - arg.numero;
		//System.out.println(nome.compareTo(arg.nome));
		return nome.compareTo(arg.nome);		
    }
}
