//
//   This file contains the Java code from Program 5.16 of
//   "Data Structures and Algorithms
//    with Object-Oriented Design Patterns in Java"
//   by Bruno R. Preiss.
//
//   Copyright (c) 1998 by Bruno R. Preiss, P.Eng.  All rights reserved.
//
//   http://www.pads.uwaterloo.ca/Bruno.Preiss/books/opus5/programs/pgm05_16.txt
//

package fundamentos;

public class Association
    extends AbstractObject
{
    protected Comparable key;
    protected Object value;

    
    public Association (Comparable key, Object value)
    {
	this.key = key;
	this.value = value;
    }

    public Association (Comparable key)
	{ this (key, null); }

    public Comparable getKey ()
	{ return key; }

    public Object getValue ()
	{ return value; }
    protected int compareTo (Comparable object)
    {
	Association association = (Association) object;
	return key.compare (association.getKey ());
    }

    //O metdo hashcode foi posto aqui, por causa do cap8.
    //http://www.brpreiss.com/books/opus5/programs/pgm08_01.txt    
    public int hashCode ()
    { return key.hashCode (); }

    public String toString ()
    {
	String result = "Association {" + key;
	if (value != null)
	    result += ", " + value;
	return result + "}";
    }
}
